// ==UserScript==
// @name         ShuaBeiLogin
// @namespace   https://f.alipay.com/
// @version      0.1
// @description  Simulate user login for AliPay
// @author       zjj
// @match        https://auth.alipay.com/login/index.htm?needTransfer=true&goto=http://f.alipay.com/moonlight/channel.htm
// @grant        none
// @require    http://code.jquery.com/jquery-2.2.4.js
// ==/UserScript==
jQuery.noConflict();
jQuery.ajaxSetup({
    async : false
});

var shutdownBind = null;
var interval = 500;
var timeout  = 5000;
var doTimeout = true;

var loginUrl = "auth.alipay.com/login/index.htm?needTransfer=true&goto=http://f.alipay.com/moonlight/index.htm";
var channelUrl = "https://f.alipay.com/moonlight/index.htm"; //登陆后进入的页面
var userNameInput = "#J-input-user";
var passwordInput = "#password_rsainput";
var loginBtn = "#J-login-btn";
var captchaImgID = "#J-checkcode-img";

//情况一，首次登陆webView自动抓取app端用户输入信息，当用户在app端点击登陆时，调用autoLogin并传入用户名密码。如果有验证码，转至webview，由用户输入验证码，点击登陆。
//情况二，用户信息已加挂。app端从assert平台获取用户名、密码，调用autoLogin并传入用户名、密码登陆
jQuery(function(){
	//1.告知客户端登陆页面已加载完毕，可以开始登陆
	startAutoLogin();
	//2.检查是否需要输入验证码
    Check4Captcha();
    //3.捕捉app端输入的用户名、密码
    shutdownBind = self.setInterval(GetUserInfo,interval);
});

//页面加载完成，开始通知app可以调用自动登录接口
function startAutoLogin(){
	//1.检查登陆页是否加载
	if(window.location.href.indexOf(loginUrl)!=-1){
		//2.激活“帐密登陆”，切换至输入户名帐密登陆模式
		jQuery("li[data-status='show_login']").addClass('active');
		//3.通知客户端已准备好自动登陆，客户端将调用autoLogin
		callBackJSCrawlStatus('{"status":"10"}');
	}
}

//判断是否需要输入验证码
function Check4Captcha(){
    var ifrm = jQuery(captchaImgID);
    //假如验证码图片存在，回调app，通知打码
    if(ifrm){
        ifrm.onload = function(){
            var v = jQuery(captchaImg).attr("src");
            if(v !== "" && v !== null && v !== undefined){
                doTimeout = false;
                callBackStatus('{"status":"9"}');
                console.log("========需要验证码=========");
            }
        };
    }
}

//1.首次登陆：点击登陆后调用该方法
//2.已加挂用户：从后端获取用户名、密码后调用该方法
//若出现验证码则无超时限制
function autoLogin(username,password){
    if(password){
        console.log("======自动登陆======");
		var userInfo ={};
		userInfo.username=username;
		userInfo.password=password;
		callBackEmailUserInfo(JSON.stringify(userInfo));
        jQuery(userNameInput).val(username);
        jQuery(passwordInput).val(password);
        jQuery(loginBtn).trigger('click');
    }
    //判断是否登陆成功
	setTimeout(isSuccess,timeout);
}

//调用自动登陆5秒之后还没跳转认为自动登陆失败
function isSuccess(){
	//默认登陆后进入index.htm
    if(window.location.href !== channelUrl){
        if(doTimeout){
          console.log("--------登陆失败了--------");
          jQuery(passwordInput).val("");
          callBackStatus('{"status":"9"}');
        }
    }
}

function GetUserInfo(){
    console.log("bind");
    jQuery(userNameInput).bind('blur',onblur);
    jQuery(passwordInput).bind('blur',onblur);
}

//焦点移出事件
function onblur(){
    findAP();
}

function shutDownJSCrawl(){
	//触发该方法，则认为绑定成功
    self.clearInterval(shutdownBind);
    shutdownBind = null;
}

function findAP(){
    //触发该方法，则认为绑定成功
    self.clearInterval(shutdownBind);
    shutdownBind = null;

    username=jQuery(userNameInput).val().toLowerCase();
    password=jQuery(passwordInput).val();

    if(password !== null && password !== "" && password !== undefined){
        console.log('{"username":"'+username+'","password":"'+password+'"}');
        // 回调一账通数据传输接口
        callBackJSCrawlUserInfo('{"username":"'+username+'","password":"'+password+'"}');
    }
}